# $Header: /raid/cvsroot/rt/lib/rt/ui/web/auth.pm,v 1.21 1999/06/29 21:20:23 jesse Exp $
#
# WebAuth is part of RT: Request Tracker.
# RT is (c) Copyright 1996-1999 Jesse Vincent
# RT is distributed under the terms of the GNU General Public License
#
package WebAuth;
#$AuthRealm="Default Realm Name";
require rt::database;
use CGI::Cookie;
&rt::connectdb();
$debug =0;

sub AuthCheck () {
    my ($AuthRealm) = @_;
    my ($hash, $Name, $ctx, $Pass,$path, $set_user, $set_pass);
    #lets get the cookies
    
if ($rt::program =~ /nph-/) {

      print "HTTP/1.0 200 Ok\n";
    }
	
    #get the path
#    if ($ENV{'SCRIPT_NAME'} =~ m|^(.*)/(.*?)$|) {
#      	$path=$1;
	# remove trailing slashes
#    	$path =~ s|/+$||;
#	}
    


    #lets generate that hash.

  use Digest::MD5;
    $ctx = Digest::MD5->new;
    $ctx->add($rt::ui::web::FORM{'username'});
    $ctx->add($ENV{'REMOTE_ADDR'});
    $ctx->add($rt::ui::web::FORM{'password'});
    $hash = $ctx->hexdigest();
    
    # lets set the user/pass cookies
    
    
    if  ( ( length($rt::ui::web::FORM{'username'}) ) and 
	  ( length($rt::ui::web::FORM{'password'}) >= $rt::user_passwd_min) ) {
      print STDERR "We've done FORMbased auth. now we're setting cookies\n" if $debug;
      #if we have a $path to play with...
      #not doing this breaks netscape
      
      $set_user = new CGI::Cookie(-name => 'RT_USERNAME',
                                  -value => "$rt::ui::web::FORM{'username'}",
                                  -expires => '+6M');
      $set_password = new CGI::Cookie(-name => 'RT_PASSWORD',
                                      -value =>$hash);
      
#      if ($path ne '') { 
#	$set_user->path($path);
#	$set_password->path($path);
#      }
      
      
      if (($rt::web_auth_cookies_allow_no_path =~ /yes/i) and
	  ($rt::ui::web::FORM{'insecure_path'})) {
      	$set_password->path('');
	$set_user->path('');
      } 
      
      print "Set-Cookie: $set_password\n";
      print "Set-Cookie: $set_user\n";   
      
      
      print STDERR "Set-Cookie: $set_password\n" if $debug;
      print STDERR  "Set-Cookie: $set_user\n" if $debug;
      
      return( $rt::ui::web::FORM{'username'}, $hash);
    }
    
    #otherwise, we've got cookies.
    elsif (!($rt::ui::web::cookies{'RT_PASSWORD'}) or !($rt::ui::web::cookies{'RT_USERNAME'})) {
      return (undef,undef); 
    }

    else {
      return( $rt::ui::web::cookies{'RT_USERNAME'}->value, $rt::ui::web::cookies{'RT_PASSWORD'}->value );
    }
    
  }

sub AuthForceLogout () {
  #this routine is deprecated
  return(&AuthForceLogin(@_));
}

sub AuthForceLogin () {
  local ($AuthRealm) = @_;
  my ($default_user, $path);
  
  
  
  # lets set the user/pass cookies
  
  if ($ENV{'SCRIPT_NAME'} =~ /(.*)\/(.*?)/) {
    $path=$1;      
  }
  
  # check for existing cookies and kill 'em
  #
  # be carefull here, according to RFC 2109 a cookie can only
  # be deleted, if it has existed before and "Max-Age" (aka expires)
  # is zero. A non-existing cookie with Max-Age 0 is *created* instead
  #
  %cookies = fetch CGI::Cookie;
  if(exists $cookies{'RT_PASSWORD'}) {
    my $pass_cookie;
    
    $pass_cookie = $cookies{'RT_PASSWORD'};     
    $pass_cookie->expires('now');
    $pass_cookie->value('');
    print "Set-Cookie: ", $pass_cookie, "\n";
    print STDERR  "Set-Cookie: $pass_cookie\n" if $debug;  }
  
  # comment this, if you want to keep your username (we don't)
  if(exists $cookies{'RT_USERNAME'}) {
    my $name_cookie;
    $name_cookie = $cookies{'RT_USERNAME'};
    $name_cookie->expires('now');
    $name_cookie->value('');
    print "Set-Cookie: ", $name_cookie, "\n";
    
    print STDERR  "Set-Cookie: $name_cookie\n" if $debug; }
  
  &rt::ui::web::header;
  
  if  ($rt::ui::web::cookies{'RT_USERNAME'}) {
    $default_user =  $rt::ui::web::cookies{'RT_USERNAME'}->value;
    
  }
  if ($ENV{'QUERY_STRING'} ne 'display=Logout') {
    $NewQuery = $ENV{'QUERY_STRING'};
      }
  else {
    $NewQuery= "";
  }
  print "
<center>
<table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH=\"640\" >
<tr align=\"left\">
<td> 
<div align=right>
<a href=\"http://www.ccuec.unicamp.br/index.html\">
<img src=\"/webrt/topo_ccuec.gif\" width=\"247\" height=\"43\" align=\"left\" border=\"0\">
</a>
</div>
</td> 
</tr> 
<tr> 
<td VALIGN=TOP>
<img src=\"/webrt/barra_solserv.gif\" width=\"640\" height=\"37\" usemap=\"#Map\" border=\"0\">
<map name=\"Map\">
<area shape=\"rect\" coords=\"9,14,234,34\" href=\"http://www.ead.unicamp.br/rt/webrt.cgi\">
</map>
<img src=\"/webrt/espaco1.gif\" width=\"640\" height=\"10\">
</td> 
</tr> 
</table> 

</center>
</TABLE>
    
    <FORM ACTION=\"$rt::ui::web::ScriptURL?$NewQuery\" METHOD=\"POST\">


<CENTER>
      <TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 BGCOLOR=\"#EEEEEE\">

<TR VALIGN=\"TOP\">
<TD COLSPAN=3>
<TABLE WIDTH=\"100%\" CELLPADDING=10 CELLSPACING=0 BORDER=0>
<TR ALIGN=\"LEFT\">
<TD VALIGN=\"MIDDLE\" BGCOLOR=\"#CCCCCC\">
<b>$AuthRealm Login:</b>
</TD></TR>
</TABLE>
</TD>

<TD ROWSPAN=\"4\" width=8 bgcolor=\"#ffffff\">
<IMG SRC=\"/webrt/srs.gif\" width=16 height=250 alt=\"\"></TD>
</TR>  
<TR>
<TD ALIGN=\"RIGHT\">
Usurio:&nbsp;
</TD>
<TD >
<input name=\"username\" VALUE=\"$default_user\" size=\"20\">
</TD>
<TD>&nbsp;</TD>
</TR>
<TR>
<TD ALIGN=\"RIGHT\">
Senha:&nbsp;
</TD>
<TD>
<input name=\"password\" type=\"password\" size=\"20\">
</TD>
<TD>&nbsp;</TD>
</TR>
<TR><TD align=\"right\" VALIGN=\"TOP\">";
  if ($rt::web_auth_cookies_allow_no_path =~ /yes/i) {
  
#print "
#<INPUT TYPE=\"CHECKBOX\" name=\"insecure_path\">
#</td>
#<td ALIGN=\"LEFT\" VALIGN=\"TOP\">
#&nbsp;
#<font size=\"12pt\">
#<B>
#Send authentication info to all scripts on this server.
#</B>
#</font>
#<br>
#<font size=\"12pt\">
#(If you're having trouble with RT and IE4.01sp1, check here.)
#<BR>
#<font size=\"-2\" color=\"red\">
#&nbsp;On a server with potentially malicious scripts, this could be a security risk.
#</font>
#<br>";
}
else {
print "&nbsp;</TD><TD>";
}  
print "&nbsp;</td>
<TD ALIGN=\"LEFT\">
<INPUT TYPE=\"SUBMIT\" VALUE=\"Login\">
</TD>
</TR>


<TR VALIGN=\"TOP\">
<TD COLSPAN=3><img src=\"/webrt/sbs.gif\" width=520 height=16 alt=\"\"></TD>
<TD ALIGN=\"LEFT\" BGCOLOR=\"#ffffff\"><img src=\"/webrt/sbc.gif\" width=12 alt=\"\" height=16></TD>
</TR>
</TABLE>
</CENTER>

<br><br>


<TABLE BORDER=0>
<td><tr>
<hr>
<P><A HREF=\"http://www.fsck.com\">
Request Tracker</A><BR>
Copyright &copy; 1996-1999
<a href=\"http://www.fsck.com/~jesse/\">Jesse Vincent</a>.
</font>
</TD></TR>
</TABLE>

</FORM>

</BODY>
";
  
  &rt::ui::web::content_footer;
  
}

# return a username if the HTTPd has authenticated for us
# undefined otherwise
sub HTTP_AuthAvailable() {
  # make sure that we are called by the httpd or by the rt-user
    if(($EUID == $UID) || ($UID == $http_user)) {
      return $ENV{'REMOTE_USER'};
    }
    return undef;
  }    



1;

